// Конфигурация кнопок
var buttonConfigs = {
    button1: {
        message: "Переключить лампу 1?",
        action: 1 // Числовой код для лампы 1
    },
    button2: {
        message: "Переключить лампу 2?",
        action: 2 // Числовой код для лампы 2
    }
};

// 1. Виртуальное устройство для управления диалогом
defineVirtualDevice("warning_dialog", {
    title: "Управление лампами",
    cells: {
        activate_button1: {
            type: "switch",
            value: false,
            control: { type: "button", label: "Лампа 1" }
        },
        activate_button2: {
            type: "switch",
            value: false,
            control: { type: "button", label: "Лампа 2" }
        },
        visible: {
            type: "switch",
            value: false,
            control: { type: "none" }
        },
        message: {
            type: "text",
            value: "",
            control: { type: "none" }
        },
        action: {
            type: "value", // Используем числовой тип вместо "text"
            value: 0,
            control: { type: "none" }
        },
        yes: {
            type: "switch",
            value: false,
            control: { type: "button", label: "Да" }
        },
        no: {
            type: "switch",
            value: false,
            control: { type: "button", label: "Нет" }
        }
    }
});

// 2. Обработчики активации
defineRule("handleButton1", {
    whenChanged: "warning_dialog/activate_button1",
    then: function (newVal) {
        if (newVal) {
            dev["warning_dialog/action"] = buttonConfigs.button1.action; // Сохраняем число 1
            dev["warning_dialog/message"] = buttonConfigs.button1.message;
            dev["warning_dialog/visible"] = true;
            dev["warning_dialog/activate_button1"] = false;
        }
    }
});

defineRule("handleButton2", {
    whenChanged: "warning_dialog/activate_button2",
    then: function (newVal) {
        if (newVal) {
            dev["warning_dialog/action"] = buttonConfigs.button2.action; // Сохраняем число 2
            dev["warning_dialog/message"] = buttonConfigs.button2.message;
            dev["warning_dialog/visible"] = true;
            dev["warning_dialog/activate_button2"] = false;
        }
    }
});

// 3. Обработчик кнопки "Да"
defineRule("handleYes", {
    whenChanged: "warning_dialog/yes",
    then: function (newVal) {
        if (newVal) {
            var actionCode = dev["warning_dialog/action"];

            // Преобразуем числовой код в топик лампы
            var targetLamp = (actionCode === 1) ? "lamp1" : "lamp2";
            dev[targetLamp + "/power"] = !dev[targetLamp + "/power"];

            dev["warning_dialog/yes"] = false;
            dev["warning_dialog/visible"] = false;
        }
    }
});

// 4. Обработчик кнопки "Нет"
defineRule("handleNo", {
    whenChanged: "warning_dialog/no",
    then: function (newVal) {
        if (newVal) {
            dev["warning_dialog/no"] = false;
            dev["warning_dialog/visible"] = false;
        }
    }
});